fix ssh tunnel creation
[doctor.git] / tests / run.sh
index ae030e2..4189700 100755 (executable)
@@ -8,7 +8,7 @@
 # http://www.apache.org/licenses/LICENSE-2.0
 ##############################################################################
 
-[[ "${CI_DEBUG:-true}" == "true" ]] && set -x
+[[ "${CI_DEBUG:-true}" == [Tt]rue ]] && set -x
 
 IMAGE_URL=https://launchpad.net/cirros/trunk/0.3.0/+download/cirros-0.3.0-x86_64-disk.img
 IMAGE_NAME=cirros
@@ -25,8 +25,8 @@ DOCTOR_PROJECT=doctor
 #TODO: change back to `_member_` when JIRA DOCTOR-55 is done
 DOCTOR_ROLE=admin
 
-SUPPORTED_INSTALLER_TYPES="apex local"
-INSTALLER_TYPE=${INSTALLER_TYPE:-apex}
+SUPPORTED_INSTALLER_TYPES="apex fuel local"
+INSTALLER_TYPE=${INSTALLER_TYPE:-local}
 INSTALLER_IP=${INSTALLER_IP:-none}
 
 ssh_opts="-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
@@ -41,12 +41,13 @@ fi
 get_compute_host_info() {
     # get computer host info which VM boot in
     COMPUTE_HOST=$(openstack $as_doctor_user server show $VM_NAME |
-                   grep "OS-EXT-SRV-ATTR:host" | awk '{ print $4 }' |
-                   awk -F '.' '{print $1}')
+                   grep "OS-EXT-SRV-ATTR:host" | awk '{ print $4 }')
+    compute_host_in_undercloud=${COMPUTE_HOST%%.*}
     if [[ -z "$COMPUTE_HOST" ]] ; then
         echo "ERROR: failed to get compute hostname"
         exit 1
     fi
+
     if [[ "$INSTALLER_TYPE" == "apex" ]] ; then
         COMPUTE_USER=${COMPUTE_USER:-heat-admin}
         if [[ "$INSTALLER_IP" == "none" ]] ; then
@@ -55,17 +56,29 @@ get_compute_host_info() {
         fi
         COMPUTE_IP=$(sudo ssh $ssh_opts $INSTALLER_IP \
              "source stackrc; \
-             nova show $COMPUTE_HOST \
+             nova show $compute_host_in_undercloud \
              | awk '/ ctlplane network /{print \$5}'")
+    elif [[ "$INSTALLER_TYPE" == "fuel" ]] ; then
+        COMPUTE_USER=${COMPUTE_USER:-root}
+        if [[ "$INSTALLER_IP" == "none" ]] ; then
+            instack_mac=$(sudo virsh domiflist fuel-opnfv | awk '/pxebr/{print $5}')
+            INSTALLER_IP=$(/usr/sbin/arp -e | grep ${instack_mac} | awk '{print $1}')
+        fi
+        node_id=$(echo $compute_host_in_undercloud | cut -d "-" -f 2)
+        COMPUTE_IP=$(sshpass -p r00tme ssh 2>/dev/null $ssh_opts root@${INSTALLER_IP} \
+             "fuel node|awk -F '|' -v id=$node_id '{if (\$1 == id) print \$5}' |xargs")
     elif [[ "$INSTALLER_TYPE" == "local" ]] ; then
         COMPUTE_USER=${COMPUTE_USER:-$(whoami)}
         COMPUTE_IP=$(getent hosts "$COMPUTE_HOST" | awk '{ print $1 }')
-        if [[ -z "$COMPUTE_IP" ]]; then
-            echo "ERROR: Could not resolve $COMPUTE_HOST. Either manually set COMPUTE_IP or enable DNS resolution."
-            exit 1
-        fi
     fi
 
+    if [[ -z "$COMPUTE_IP" ]]; then
+        echo "ERROR: Could not resolve $COMPUTE_HOST. Either manually set COMPUTE_IP or enable DNS resolution."
+        exit 1
+    fi
+    echo "COMPUTE_HOST=$COMPUTE_HOST"
+    echo "COMPUTE_IP=$COMPUTE_IP"
+
     # verify connectivity to target compute host
     ping -c 1 "$COMPUTE_IP"
     if [[ $? -ne 0 ]] ; then
@@ -83,6 +96,11 @@ prepare_compute_ssh() {
         sudo chown $(whoami):$(whoami) instack_key
         chmod 400 instack_key
         ssh_opts_cpu+=" -i instack_key"
+    elif [[ "$INSTALLER_TYPE" == "fuel" ]] ; then
+        sshpass -p r00tme scp $ssh_opts root@${INSTALLER_IP}:.ssh/id_rsa instack_key
+        sudo chown $(whoami):$(whoami) instack_key
+        chmod 400 instack_key
+        ssh_opts_cpu+=" -i instack_key"
     elif [[ "$INSTALLER_TYPE" == "local" ]] ; then
         echo "INSTALLER_TYPE set to 'local'. Assuming SSH keys already exchanged with $COMPUTE_HOST"
     fi
@@ -96,17 +114,14 @@ prepare_compute_ssh() {
 }
 
 get_consumer_ip() {
-    #get network of the compute_ip address
-    network_pre=${COMPUTE_IP%.*}
-    network=${network_pre}.0/24
-
-    #if there is a dedicated route, use it
-    dev=$(ip route |grep $network | awk '{print $3}' |head -n 1)
+    CONSUMER_IP=$(sudo ssh $ssh_opts root@$INSTALLER_IP \
+                  "ip route get $COMPUTE_IP | awk '/ src /{print \$NF}'")
+    echo "CONSUMER_IP=$CONSUMER_IP"
 
-    #if there is no route, use default route
-    [[ -z $dev ]] && dev=$(ip route |grep ^default | awk '{print $3}' |head -n 1)
-
-    CONSUMER_IP=$(ip addr show $dev |grep inet | grep $network_pre | awk '{print $2}' | cut -d'/' -f1)
+    if [[ -z "$CONSUMER_IP" ]]; then
+        echo "ERROR: Could not get CONSUMER_IP."
+        exit 1
+    fi
 }
 
 download_image() {
@@ -160,6 +175,11 @@ create_alarm() {
         -q "traits.state=string::error; traits.instance_id=string::$vm_id"
 }
 
+print_log() {
+    log_file=$1
+    echo "$log_file:"
+    sed -e 's/^/    /' "$log_file"
+}
 
 start_monitor() {
     pgrep -f "python monitor.py" && return 0
@@ -170,7 +190,7 @@ start_monitor() {
 stop_monitor() {
     pgrep -f "python monitor.py" || return 0
     sudo kill $(pgrep -f "python monitor.py")
-    cat monitor.log
+    print_log monitor.log
 }
 
 start_inspector() {
@@ -181,18 +201,25 @@ start_inspector() {
 stop_inspector() {
     pgrep -f "python inspector.py" || return 0
     kill $(pgrep -f "python inspector.py")
-    cat inspector.log
+    print_log inspector.log
 }
 
 start_consumer() {
     pgrep -f "python consumer.py" && return 0
     python consumer.py "$CONSUMER_PORT" > consumer.log 2>&1 &
+    # NOTE(r-mibu): create tunnel to the installer node, so that we can
+    # avoid some network problems dpends on infra and installers.
+    # This tunnel will be terminated by stop_consumer() or after 10 mins passed.
+    TUNNEL_COMMAND="sudo ssh $ssh_opts $INSTALLER_IP -R $CONSUMER_PORT:localhost:$CONSUMER_PORT sleep 600"
+    $TUNNEL_COMMAND > ssh_tunnel.log 2>&1 < /dev/null &
 }
 
 stop_consumer() {
     pgrep -f "python consumer.py" || return 0
     kill $(pgrep -f "python consumer.py")
-    cat consumer.log
+    print_log consumer.log
+    kill $(pgrep -f "$TUNNEL_COMMAND")
+    print_log ssh_tunnel.log
 }
 
 wait_for_vm_launch() {
@@ -231,6 +258,10 @@ END_TXT
 calculate_notification_time() {
     detected=$(grep "doctor monitor detected at" monitor.log | awk '{print $5}')
     notified=$(grep "doctor consumer notified at" consumer.log | awk '{print $5}')
+    if ! grep -q "doctor consumer notified at" consumer.log ; then
+        echo "ERROR: consumer hasn't received fault notification."
+        exit 1
+    fi
     echo "$notified $detected" | \
         awk '{d = $1 - $2; if (d < 1 && d > 0) print d " OK"; else print d " NG"}'
 }
@@ -244,11 +275,11 @@ check_host_status() {
     if [ -z "$host_status" ] ; then
         echo "ERROR: host_status not reported by: nova show $VM_NAME"
         exit 1
-    elif [[ "$host_status" != "$expected_state" ]] ; then
+    elif [[ "$expected_state" =~ "$host_status" ]] ; then
+        echo "$VM_NAME showing host_status: $host_status"
+    else
         echo "ERROR: host_status:$host_status not equal to expected_state: $expected_state"
         exit 1
-    else
-        echo "$VM_NAME showing host_status: $host_status"
     fi
 }
 
@@ -261,10 +292,10 @@ cleanup() {
 
     echo "waiting disabled compute host back to be enabled..."
     python ./nova_force_down.py "$COMPUTE_HOST" --unset
-    sleep 180
+    sleep 240
     check_host_status "UP"
-    ssh $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP" \
-        "[ -e disable_network.log ] && cat disable_network.log"
+    scp $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP:disable_network.log" .
+    print_log disable_network.log
 
     openstack $as_doctor_user server list | grep -q " $VM_NAME " && openstack $as_doctor_user server delete "$VM_NAME"
     sleep 1
@@ -297,6 +328,7 @@ create_test_user
 echo "creating VM..."
 boot_vm
 wait_for_vm_launch
+openstack $as_doctor_user server show $VM_NAME
 
 echo "get computer host info and prepare to ssh..."
 get_compute_host_info
@@ -314,9 +346,9 @@ start_consumer
 sleep 60
 echo "injecting host failure..."
 inject_failure
-sleep 10
+sleep 60
 
-check_host_status "DOWN"
+check_host_status "(DOWN|UNKNOWN)"
 calculate_notification_time
 
 echo "done"